## gnu-efi 3.0.2

=== Makefile ===
#
#  Copyright (C) 1999-2007 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

VERSION = 3.0.2

SRCDIR = $(shell pwd)

VPATH = $(SRCDIR)

include $(SRCDIR)/Make.defaults

SUBDIRS = lib gnuefi inc apps
gnuefi: lib

all:	check_gcc $(SUBDIRS)

mkvars:
	@echo AR=$(AR)
	@echo ARCH=$(ARCH)
	@echo ARCH3264=$(ARCH3264)
	@echo AS=$(AS)
	@echo ASFLAGS=$(ASFLAGS)
	@echo CC=$(CC)
	@echo CFLAGS=$(CFLAGS)
	@echo CPPFLAGS=$(CPPFLAGS)
	@echo GCCMINOR=$(GCCMINOR)
	@echo GCCNEWENOUGH=$(GCCNEWENOUGH)
	@echo GCCVERSION=$(GCCVERSION)
	@echo HOSTARCH=$(HOSTARCH)
	@echo INCDIR=$(INCDIR)
	@echo INSTALL=$(INSTALL)
	@echo INSTALLROOT=$(INSTALLROOT)
	@echo LD=$(LD)
	@echo LDFLAGS=$(LDFLAGS)
	@echo LIBDIR=$(LIBDIR)
	@echo OBJCOPY=$(OBJCOPY)
	@echo OS=$(OS)
	@echo prefix=$(prefix)
	@echo PREFIX=$(PREFIX)
	@echo RANLIB=$(RANLIB)
	@echo SRCDIR=$(SRCDIR)
	@echo TOPDIR=$(TOPDIR)

$(SUBDIRS):
	mkdir -p $(OBJDIR)/$@
	$(MAKE) -C $(OBJDIR)/$@ -f $(SRCDIR)/$@/Makefile SRCDIR=$(SRCDIR)/$@ ARCH=$(ARCH)

clean:
	rm -f *~
	@for d in $(SUBDIRS); do \
		if [ -d $(OBJDIR)/$$d ]; then \
			$(MAKE) -C $(OBJDIR)/$$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d clean; \
		fi; \
	done

install:
	@for d in $(SUBDIRS); do \
		mkdir -p $(OBJDIR)/$$d; \
		$(MAKE) -C $(OBJDIR)/$$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d install; done

.PHONY:	$(SUBDIRS) clean depend

#
# on both platforms you must use gcc 3.0 or higher 
#
check_gcc:
ifeq ($(GCC_VERSION),2)
	@echo "you need to use a version of gcc >= 3.0, you are using `$(CC) --version`"
	@exit 1
endif

include $(SRCDIR)/Make.rules

test-archive:
	@rm -rf /tmp/gnu-efi-$(VERSION) /tmp/gnu-efi-$(VERSION)-tmp
	@mkdir -p /tmp/gnu-efi-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/gnu-efi-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/gnu-efi-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/gnu-efi-$(VERSION)-tmp/ /tmp/gnu-efi-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/gnu-efi-$(VERSION).tar.bz2 gnu-efi-$(VERSION)
	@rm -rf /tmp/gnu-efi-$(VERSION)
	@echo "The archive is in gnu-efi-$(VERSION).tar.bz2"

tag:
	git tag $(VERSION) refs/heads/master

archive: tag
	@rm -rf /tmp/gnu-efi-$(VERSION) /tmp/gnu-efi-$(VERSION)-tmp
	@mkdir -p /tmp/gnu-efi-$(VERSION)-tmp
	@git archive --format=tar $(VERSION) | ( cd /tmp/gnu-efi-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/gnu-efi-$(VERSION)-tmp/ /tmp/gnu-efi-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/gnu-efi-$(VERSION).tar.bz2 gnu-efi-$(VERSION)
	@rm -rf /tmp/gnu-efi-$(VERSION)
	@echo "The archive is in gnu-efi-$(VERSION).tar.bz2"

=== apps/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..
LINUX_HEADERS	= /usr/src/sys/build
CPPFLAGS	+= -D__KERNEL__ -I$(LINUX_HEADERS)/include
CRTOBJS		= ../gnuefi/crt0-efi-$(ARCH).o

LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_efi.lds
ifneq (,$(findstring FreeBSD,$(OS)))
LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_fbsd_efi.lds
endif

LDFLAGS		+= -shared -Bsymbolic -L../lib -L../gnuefi $(CRTOBJS)

LOADLIBES	+= -lefi -lgnuefi
LOADLIBES	+= $(LIBGCC)
LOADLIBES	+= -T $(LDSCRIPT)

TARGET_APPS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi \
	      printenv.efi t7.efi t8.efi tcc.efi modelist.efi \
	      route80h.efi drv0_use.efi AllocPages.efi \
	      FreePages.efi
TARGET_BSDRIVERS = drv0.efi
TARGET_RTDRIVERS =

ifneq ($(HAVE_EFI_OBJCOPY),)

FORMAT		:= --target efi-app-$(ARCH)
$(TARGET_BSDRIVERS): FORMAT=--target efi-bsdrv-$(ARCH)
$(TARGET_RTDRIVERS): FORMAT=--target efi-rtdrv-$(ARCH)

else

SUBSYSTEM	:= 0xa
$(TARGET_BSDRIVERS): SUBSYSTEM = 0xb
$(TARGET_RTDRIVERS): SUBSYSTEM = 0xc

FORMAT		:= -O binary
LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)

endif

TARGETS = $(TARGET_APPS) $(TARGET_BSDRIVERS) $(TARGET_RTDRIVERS)

all:	$(TARGETS)

clean:
	rm -f $(TARGETS) *~ *.o *.so

.PHONY: install

include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR = $(TOPDIR)/..
FILES = boxdraw smbios console crc data debug dpath  \
        error event guid hand hw init lock   \
        misc print sread str cmdline \
	runtime/rtlock runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata  \
	$(ARCH)/initplat $(ARCH)/math 

ifeq ($(ARCH),ia64)
FILES += $(ARCH)/salpal $(ARCH)/palproc
endif

ifeq ($(ARCH),x86_64)
FILES += $(ARCH)/callwrap $(ARCH)/efi_stub
endif

ifeq ($(ARCH),arm)
FILES += $(ARCH)/lib1funcs $(ARCH)/div64
endif

OBJS  = $(FILES:%=%.o)

SUBDIRS = ia32 x86_64 ia64 aarch64 arm runtime

LIBDIRINSTALL = $(INSTALLROOT)$(LIBDIR)

all: libsubdirs libefi.a

.PHONY: libsubdirs
libsubdirs:
	for sdir in $(SUBDIRS); do mkdir -p $$sdir; done

libefi.a: $(patsubst %,libefi.a(%),$(OBJS))

clean:
	rm -f libefi.a *~ $(OBJS) */*.o

$(LIBDIRINSTALL):
	mkdir -p $@

$(LIBDIRINSTALL)/libefi.a: libefi.a | $(LIBDIRINSTALL)
	$(INSTALL) -m 644 $< $(dir $@)

install: $(LIBDIRINSTALL)/libefi.a

include $(SRCDIR)/../Make.rules

.PHONY: libsubdirs

=== debian/changelog ===
gnu-efi (3.0.2-1ubuntu1) wily; urgency=medium

  * Merge with Debian unstable, remaining changes: 
    - debian/patches/gcc46-compatibility: don't break with old compilers
      and -DGNU_EFI_USE_MS_ABI.

 -- Mario Limonciello <Mario_Limonciello@Dell.com>  Thu, 04 Jun 2015 17:35:25 -0500

gnu-efi (3.0.2-1) unstable; urgency=medium

  * Imported Upstream version 3.0.2
  * debian/rules: Simplify by using upstream Makefile for install
  * debian/control: Bump Standards-Version to 3.9.6
  * debian/copyright: Remove spaces from License keyword
  * Add any-arm and any-arm64 to the architecture list
  * inc-efistdarg.h-Use-gcc-builtins-instead-of-stdarg.h.patch: Applied upstream

 -- Julian Andres Klode <jak@debian.org>  Thu, 25 Sep 2014 15:53:43 +0200

gnu-efi (3.0v-5ubuntu1) wily; urgency=medium

  * Merge from Debian unstable (LP: #1396381), remaining changes:
    - debian/patches/gcc46-compatibility: don't break with old compilers
      and -DGNU_EFI_USE_MS_ABI.
  * Dropped changes, included in Debian:
    - pass architecture arguments when building the x86_64 code on i386

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 May 2015 17:45:11 +0000

=== debian/control ===
Source: gnu-efi
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Julian Andres Klode <jak@debian.org>
Uploaders: Nigel Croxon <nigel.croxon@hp.com>
Build-Depends:
 debhelper (>= 9),
 binutils,
 gcc-multilib [amd64 i386 kfreebsd-amd64],
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/collab-maint/gnu-efi.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gnu-efi.git
Homepage: http://sourceforge.net/projects/gnu-efi/

Package: gnu-efi
Architecture: amd64 i386 ia64 kfreebsd-amd64 any-arm any-arm64
Depends: ${misc:Depends}
Description: Library for developing EFI applications
 GNU toolchain for building applications that can run in the environment
 presented by Intel's EFI (Extensible Firmware Interface). EFI is a firmware
 specification for the "BIOS" on ia64(IPF), IA-32(x86) and x86_64 systems.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# The architecture we are building on
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	BUILD_ARCH := ia32
else ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	BUILD_ARCH := x86_64
else
	BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
endif

# The architecture we are building for
ifneq (,$(findstring i386,$(DEB_HOST_ARCH)))
	HOST_ARCH := ia32
	COMPAT_ARCH := x86_64
	COMPAT_APPEND := 64
else ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
	HOST_ARCH := x86_64
	COMPAT_ARCH := ia32
	COMPAT_APPEND := 32
else
	# ARM CPUs
	HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
endif

%:
	dh $@

override_dh_auto_clean:
	$(MAKE) clean ARCH=$(HOST_ARCH)
ifneq (,$(COMPAT_ARCH))
		$(MAKE) clean ARCH=$(COMPAT_ARCH) HOSTARCH=$(BUILD_ARCH)
endif

override_dh_auto_build:
	$(MAKE) ARCH=$(HOST_ARCH)
ifneq (,$(COMPAT_ARCH))
		$(MAKE) ARCH=$(COMPAT_ARCH) HOSTARCH=$(BUILD_ARCH)
endif

# Fixme: This somehow rebuilds some parts
override_dh_auto_install:
	$(MAKE) install ARCH=$(HOST_ARCH) INSTALLROOT=$(CURDIR)/debian/gnu-efi PREFIX=/usr LIBDIR=/usr/lib
ifneq (,$(COMPAT_ARCH))
	$(MAKE) install ARCH=$(COMPAT_ARCH) HOSTARCH=$(BUILD_ARCH) INSTALLROOT=$(CURDIR)/debian/gnu-efi PREFIX=/usr LIBDIR=/usr/lib$(COMPAT_APPEND)
endif

## gnu-efi 3.0.4

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 #    SUCH DAMAGE.
 #
 
-VERSION = 3.0.2
+VERSION = 3.0.4
 
 SRCDIR = $(shell pwd)

=== apps/Makefile ===
--- 
+++ 
@@ -61,7 +61,7 @@
 TARGET_APPS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi \
 	      printenv.efi t7.efi t8.efi tcc.efi modelist.efi \
 	      route80h.efi drv0_use.efi AllocPages.efi \
-	      FreePages.efi
+	      FreePages.efi setjmp.efi debughook.efi debughook.efi.debug
 TARGET_BSDRIVERS = drv0.efi
 TARGET_RTDRIVERS =

=== debian/changelog ===
gnu-efi (3.0.4-2) unstable; urgency=medium

  * aarch64: Fix invalid cast from const to non-const
  * Do not build with -Werror

 -- Julian Andres Klode <jak@debian.org>  Thu, 30 Jun 2016 13:41:30 +0200

gnu-efi (3.0.4-1) unstable; urgency=medium

  * Merge gcc 4.6 support patch from Ubuntu
  * Imported Upstream version 3.0.4
  * Add patch: "ARM: hide 'hidden' pragma for hosted build" (Closes: #828887)
  * Rebase patches against 3.0.4
  * Update copyright file, new upstream release fixes GPL issue
    (Closes: #808472)
  * debian/control: Update Vcs URIs to https
  * Bump Standards-Version to 3.9.8

 -- Julian Andres Klode <jak@debian.org>  Thu, 30 Jun 2016 11:52:10 +0200

gnu-efi (3.0.3-2) unstable; urgency=medium

  * Do not try to build multilib on non-Linux i386 builds
  * Fix building on armhf: replace @function by %function

 -- Julian Andres Klode <jak@debian.org>  Sun, 29 Nov 2015 12:32:59 +0100

gnu-efi (3.0.3-1) unstable; urgency=medium

  [ Julian Andres Klode ]
  * Simplify architecture list: drop ia64 and armel, use wildcards where possible
  * Drop Nigel Croxon from Uploaders, he's not involved in packaging
  * Update Vcs-Browser URL to point to cgit instead of gitweb
  * rules: Match architectures by CPU rather than parts of architecture
  * debian/watch: Add
  * Imported Upstream version 3.0.3

  [ Helmut Grohne ]
  * Fix FTCBFS by exporting CROSS_COMPILE (Closes: #805400)

 -- Julian Andres Klode <jak@debian.org>  Tue, 17 Nov 2015 20:59:42 +0100

=== debian/control ===
Source: gnu-efi
Section: devel
Priority: optional
Maintainer: Julian Andres Klode <jak@debian.org>
Build-Depends:
 debhelper (>= 9),
 binutils,
 gcc-multilib [any-amd64 i386],
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/gnu-efi.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/gnu-efi.git
Homepage: http://sourceforge.net/projects/gnu-efi/

Package: gnu-efi
Architecture: any-amd64 any-i386 any-arm64 armhf
Depends: ${misc:Depends}
Description: Library for developing EFI applications
 GNU toolchain for building applications that can run in the environment
 presented by Intel's EFI (Extensible Firmware Interface). EFI is a firmware
 specification for the "BIOS" on ia64(IPF), IA-32(x86) and x86_64 systems.

=== debian/watch ===
version=3
http://sf.net/gnu-efi/gnu-efi-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## gnu-efi 3.0.8

=== debian/changelog ===
gnu-efi (3.0.8-0ubuntu1~14.04.1) trusty; urgency=medium

  * New upstream version 3.0.8. (LP: #1790709)
  * debian/patches: drop patches, included upstream.
  * Reinstate d/p/ARM-hide-hidden-pragma-for-hosted-build.patch; otherwise
    sbsigntool fails to build on armhf.
  * debian/patches/intptr_define.patch: include stdint.h from inc/efilink.h.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 04 Sep 2018 15:30:59 -0400

gnu-efi (3.0.6-1~exp1) experimental; urgency=medium

  * New upstream version 3.0.6 (Closes: #880506)
  * Rebase patches against new upstream release
    - Drop ARM-hide-hidden-pragma-for-hosted-build.patch and
      aarch64-Fix-invalid-cast-from-const-to-non-const.patch, no
      longer used
  * Bump Standards-Version to 4.1.1

 -- Julian Andres Klode <jak@debian.org>  Wed, 29 Nov 2017 15:06:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: gnu-efi
 Section: devel
 Priority: optional
-Maintainer: Julian Andres Klode <jak@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Julian Andres Klode <jak@debian.org>
 Build-Depends:
  debhelper (>= 9),
  binutils,
  gcc-multilib [any-amd64 i386],
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/gnu-efi.git
 Vcs-Browser: https://anonscm.debian.org/git/collab-maint/gnu-efi.git
 Homepage: http://sourceforge.net/projects/gnu-efi/

## gnu-efi 3.0.9

=== gnuefi/Makefile ===
#
#  Copyright (C) 1999-2001 Hewlett-Packard Co.
#	Contributed by David Mosberger <davidm@hpl.hp.com>
#	Contributed by Stephane Eranian <eranian@hpl.hp.com>
#
#    All rights reserved.
#
#    Redistribution and use in source and binary forms, with or without
#    modification, are permitted provided that the following conditions
#    are met:
#
#    * Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials
#      provided with the distribution.
#    * Neither the name of Hewlett-Packard Co. nor the names of its
#      contributors may be used to endorse or promote products derived
#      from this software without specific prior written permission.
#
#    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
#    CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
#    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
#    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
#    BE LIABLE FOR ANYDIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
#    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
#    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
#    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#    SUCH DAMAGE.
#

SRCDIR = .

VPATH = $(SRCDIR)

include $(SRCDIR)/../Make.defaults

TOPDIR = $(SRCDIR)/..

CDIR=$(TOPDIR)/..
FILES	= reloc_$(ARCH)  

OBJS	= $(FILES:%=%.o)

# on aarch64, avoid jump tables before all relocations have been processed
reloc_aarch64.o: CFLAGS += -fno-jump-tables

TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a

all:	$(TARGETS)

libgnuefi.a: $(patsubst %,libgnuefi.a(%),$(OBJS))

clean:
	rm -f $(TARGETS) *~ *.o $(OBJS)

install:
	mkdir -p $(INSTALLROOT)$(LIBDIR)
	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)$(LIBDIR)
ifneq (,$(findstring FreeBSD,$(OS)))
 ifeq ($(ARCH),x86_64)
	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_fbsd_efi.lds $(INSTALLROOT)$(LIBDIR)
 else
	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi.lds $(INSTALLROOT)$(LIBDIR)
 endif
else
	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi.lds $(INSTALLROOT)$(LIBDIR)
endif

include $(SRCDIR)/../Make.rules

=== debian/changelog ===
gnu-efi (3.0.9-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Wrap long lines in changelog entries: 3.0.3-1.
  * Use secure URI in debian/watch.
  * Bump debhelper from old 9 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Repository.
  * Rely on pre-initialized dpkg-architecture variables.
  * Fix day-of-week for changelog entry 3.0d-1.

  [ Julian Andres Klode ]
  * Change Maintainer to Debian EFI team
  * Point Vcs to new efi-team location

 -- Julian Andres Klode <jak@debian.org>  Thu, 04 Feb 2021 12:03:03 +0100

gnu-efi (3.0.9-1) unstable; urgency=medium

  * New upstream version 3.0.9
  * Update Vcs URIs to point to Salsa
  * Delete debian/source/options

 -- Julian Andres Klode <jak@debian.org>  Mon, 22 Oct 2018 13:44:47 +0200

gnu-efi (3.0.8-1) unstable; urgency=medium

  [ Julian Andres Klode ]
  * New upstream version 3.0.8

  [ Mathieu Trudel-Lapierre ]
  * debian/patches: drop patches, included upstream
  * Reinstate d/p/ARM-hide-hidden-pragma-for-hosted-build.patch;
    otherwise sbsigntool fails to build on armhf.

 -- Julian Andres Klode <jak@debian.org>  Wed, 10 Oct 2018 22:46:43 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: gnu-efi
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Julian Andres Klode <jak@debian.org>
+Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Uploaders: Julian Andres Klode <jak@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper-compat (= 12),
  binutils,
  gcc-multilib [any-amd64 i386],
 Standards-Version: 4.1.1
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/gnu-efi.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/gnu-efi.git
+Vcs-Git: https://salsa.debian.org/efi-team/gnu-efi.git
+Vcs-Browser: https://salsa.debian.org/efi-team/gnu-efi
 Homepage: http://sourceforge.net/projects/gnu-efi/
 
 Package: gnu-efi

=== debian/rules ===
--- 
+++ 
@@ -1,23 +1,29 @@
 #!/usr/bin/make -f
 
-DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
-DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+include /usr/share/dpkg/architecture.mk
+
+# Cross building support
+ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
+export CROSS_COMPILE = $(DEB_HOST_GNU_TYPE)-
+endif
 
 # The architecture we are building on
-ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
+ifeq (i386,$(DEB_BUILD_ARCH_CPU))
 	BUILD_ARCH := ia32
-else ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
+else ifeq (amd64,$(DEB_BUILD_ARCH_CPU))
 	BUILD_ARCH := x86_64
 else
 	BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
 endif
 
 # The architecture we are building for
-ifneq (,$(findstring i386,$(DEB_HOST_ARCH)))
+ifeq (i386,$(DEB_BUILD_ARCH_CPU))
 	HOST_ARCH := ia32
-	COMPAT_ARCH := x86_64
-	COMPAT_APPEND := 64
-else ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
+	ifeq (linux,$(DEB_BUILD_ARCH_OS))
+		COMPAT_ARCH := x86_64
+		COMPAT_APPEND := 64
+	endif
+else ifeq (amd64,$(DEB_BUILD_ARCH_CPU))
 	HOST_ARCH := x86_64
 	COMPAT_ARCH := ia32
 	COMPAT_APPEND := 32

## gnu-efi 3.0.13+git20210716.269ef9d

=== Makefile ===
--- 
+++ 
@@ -34,9 +34,10 @@
 #    SUCH DAMAGE.
 #
 
-VERSION = 3.0.4
+VERSION = 3.0.13
 
-SRCDIR = $(shell pwd)
+MKFILE_PATH := $(abspath $(lastword $(MAKEFILE_LIST)))
+SRCDIR = $(dir $(MKFILE_PATH))
 
 VPATH = $(SRCDIR)

=== debian/changelog ===
gnu-efi (3.0.13+git20210716.269ef9d-2ubuntu1) jammy; urgency=medium

  * Set NumberOfSymbols to zero in COFF header (LP: #1960340)

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 08 Feb 2022 18:12:16 +0100

gnu-efi (3.0.13+git20210716.269ef9d-2) unstable; urgency=medium

  * Upload to unstable

 -- Julian Andres Klode <jak@debian.org>  Tue, 14 Sep 2021 08:24:37 +0200

gnu-efi (3.0.13+git20210716.269ef9d-1) experimental; urgency=medium

  * New upstream version 3.0.13+git20210716.269ef9d
  * Add any-riscv64 to Architecture list (Closes: #988231) (LP: #1938324)
  * Add any-ia64 to Architecture list (Closes: #926535)
  * Drop patches; applied upstream

 -- Julian Andres Klode <jak@debian.org>  Thu, 29 Jul 2021 17:55:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: gnu-efi
 Section: devel
 Priority: optional
-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
 Uploaders: Julian Andres Klode <jak@debian.org>
 Build-Depends:
  debhelper-compat (= 12),
@@ -13,7 +14,7 @@
 Homepage: http://sourceforge.net/projects/gnu-efi/
 
 Package: gnu-efi
-Architecture: any-amd64 any-i386 any-arm64 armhf
+Architecture: any-amd64 any-i386 any-arm64 armhf any-riscv64 any-ia64
 Depends: ${misc:Depends}
 Description: Library for developing EFI applications
  GNU toolchain for building applications that can run in the environment

## gnu-efi 3.0.15

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 #    SUCH DAMAGE.
 #
 
-VERSION = 3.0.13
+VERSION = 3.0.15
 
 MKFILE_PATH := $(abspath $(lastword $(MAKEFILE_LIST)))
 SRCDIR = $(dir $(MKFILE_PATH))

=== debian/changelog ===
gnu-efi (3.0.15-1) unstable; urgency=medium

  * New upstream version 3.0.15

 -- Julian Andres Klode <jak@debian.org>  Fri, 27 Jan 2023 21:24:25 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: gnu-efi
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian EFI team <debian-efi@lists.debian.org>
+Maintainer: Debian EFI team <debian-efi@lists.debian.org>
 Uploaders: Julian Andres Klode <jak@debian.org>
 Build-Depends:
  debhelper-compat (= 12),

## gnu-efi 3.0.18

=== inc/Makefile ===
SRCDIR = .

VPATH = $(SRCDIR)
TOPDIR = $(SRCDIR)/..

include $(SRCDIR)/../Make.defaults

all:

clean:

install:
	mkdir -p $(INSTALLROOT)$(INCLUDEDIR)/efi
	mkdir -p $(INSTALLROOT)$(INCLUDEDIR)/efi/protocol
	mkdir -p $(INSTALLROOT)$(INCLUDEDIR)/efi/$(ARCH)
	$(INSTALL) -m 644 $(SRCDIR)/*.h $(INSTALLROOT)$(INCLUDEDIR)/efi
	$(INSTALL) -m 644 $(SRCDIR)/protocol/*.h $(INSTALLROOT)$(INCLUDEDIR)/efi/protocol
	$(INSTALL) -m 644 $(SRCDIR)/$(ARCH)/*.h $(INSTALLROOT)$(INCLUDEDIR)/efi/$(ARCH)
ifeq ($(ARCH),ia64)
	mkdir -p $(INSTALLROOT)$(INCLUDEDIR)/efi/protocol/ia64
	$(INSTALL) -m 644 $(SRCDIR)/protocol/ia64/*.h $(INSTALLROOT)$(INCLUDEDIR)/efi/protocol/ia64
endif

include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
--- 
+++ 
@@ -37,17 +37,15 @@
 SRCDIR = .
 
 VPATH = $(SRCDIR)
+TOPDIR = $(SRCDIR)/..
 
 include $(SRCDIR)/../Make.defaults
 
-TOPDIR = $(SRCDIR)/..
-
-CDIR = $(TOPDIR)/..
-FILES = boxdraw smbios console crc data debug dpath  \
-        error event guid hand hw init lock   \
-        misc print sread str cmdline \
+FILES = boxdraw smbios console crc data debug dpath \
+        entry error event exit guid hand hw init lock \
+        misc pause print sread str cmdline\
 	runtime/rtlock runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata  \
-	$(ARCH)/initplat $(ARCH)/math 
+	$(ARCH)/initplat $(ARCH)/math $(ARCH)/setjmp
 
 ifeq ($(ARCH),ia64)
 FILES += $(ARCH)/salpal $(ARCH)/palproc
@@ -58,12 +56,13 @@
 endif
 
 ifeq ($(ARCH),arm)
-FILES += $(ARCH)/lib1funcs $(ARCH)/div64
+FILES += $(ARCH)/uldiv $(ARCH)/ldivmod $(ARCH)/div $(ARCH)/llsl $(ARCH)/llsr \
+	 $(ARCH)/mullu
 endif
 
-OBJS  = $(FILES:%=%.o)
+OBJS  = $(FILES:%=%.o) ctors.o
 
-SUBDIRS = ia32 x86_64 ia64 aarch64 arm runtime
+SUBDIRS = ia32 x86_64 ia64 aarch64 arm mips64el riscv64 loongarch64 runtime
 
 LIBDIRINSTALL = $(INSTALLROOT)$(LIBDIR)
 
@@ -71,12 +70,15 @@
 
 .PHONY: libsubdirs
 libsubdirs:
-	for sdir in $(SUBDIRS); do mkdir -p $$sdir; done
+	@set -e ; for sdir in $(SUBDIRS); do mkdir -p $$sdir; done
 
-libefi.a: $(patsubst %,libefi.a(%),$(OBJS))
+$(OBJS): libsubdirs
+
+libefi.a: $(OBJS)
+	$(AR) $(ARFLAGS) $@ $^
 
 clean:
-	rm -f libefi.a *~ $(OBJS) */*.o
+	@rm -vf libefi.a *~ $(OBJS) */*.o
 
 $(LIBDIRINSTALL):
 	mkdir -p $@
@@ -87,5 +89,3 @@
 install: $(LIBDIRINSTALL)/libefi.a
 
 include $(SRCDIR)/../Make.rules
-
-.PHONY: libsubdirs

=== debian/changelog ===
gnu-efi (3.0.18-1) unstable; urgency=medium

  * Strip LDFLAGS before passing to the build
  * Add loong64 to arch list (Closes: #1025787)
  * Correctly set the PREFIX for the build
  * Add myself to uploaders
  * Drop unnecessary binutils build dep (Closes: #1032501)

 -- Mario Limonciello <superm1@gmail.com>  Mon, 25 Mar 2024 14:50:29 -0500

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Section: devel
 Priority: optional
 Maintainer: Debian EFI team <debian-efi@lists.debian.org>
-Uploaders: Julian Andres Klode <jak@debian.org>
+Uploaders: Julian Andres Klode <jak@debian.org>, Mario Limonciello <superm1@gmail.com>
 Build-Depends:
  debhelper-compat (= 12),
- binutils,
  gcc-multilib [any-amd64 i386],
 Standards-Version: 4.1.1
 Vcs-Git: https://salsa.debian.org/efi-team/gnu-efi.git
@@ -13,7 +12,7 @@
 Homepage: http://sourceforge.net/projects/gnu-efi/
 
 Package: gnu-efi
-Architecture: any-amd64 any-i386 any-arm64 armhf any-riscv64 any-ia64
+Architecture: any-amd64 any-i386 any-arm64 armhf any-riscv64 any-loong64 any-ia64
 Depends: ${misc:Depends}
 Description: Library for developing EFI applications
  GNU toolchain for building applications that can run in the environment

=== debian/rules ===
--- 
+++ 
@@ -42,9 +42,11 @@
 endif
 
 override_dh_auto_build:
-	$(MAKE) ARCH=$(HOST_ARCH)
+	LDFLAGS="${LDFLAGS//-Wl/}" && LDFLAGS="${LDFLAGS//,/ }" && \
+	$(MAKE) ARCH=$(HOST_ARCH) PREFIX=/usr
 ifneq (,$(COMPAT_ARCH))
-		$(MAKE) ARCH=$(COMPAT_ARCH) HOSTARCH=$(BUILD_ARCH)
+		LDFLAGS="${LDFLAGS//-Wl/}" && LDFLAGS="${LDFLAGS//,/ }" && \
+		$(MAKE) ARCH=$(COMPAT_ARCH) HOSTARCH=$(BUILD_ARCH) PREFIX=/usr
 endif
 
 # Fixme: This somehow rebuilds some parts

=== debian/watch ===
version=3
https://sf.net/gnu-efi/gnu-efi-(\d\S*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## gnu-efi 4.0.0

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 #    SUCH DAMAGE.
 #
 
-VERSION = 3.0.15
+export VERSION = 4.0.0
 
 MKFILE_PATH := $(abspath $(lastword $(MAKEFILE_LIST)))
 SRCDIR = $(dir $(MKFILE_PATH))
@@ -43,10 +43,19 @@
 
 include $(SRCDIR)/Make.defaults
 
-SUBDIRS = lib gnuefi inc apps
-gnuefi: lib
+SUBDIRS    = lib inc apps
+ifeq ($(IS_MINGW32),)
+  SUBDIRS += gnuefi
+endif
 
 all:	check_gcc $(SUBDIRS)
+
+ifeq ($(IS_MINGW32),)
+gnuefi: lib
+apps:	gnuefi
+else
+apps:	lib
+endif
 
 mkvars:
 	@echo AR=$(AR)
@@ -80,15 +89,15 @@
 	$(MAKE) -C $(OBJDIR)/$@ -f $(SRCDIR)/$@/Makefile SRCDIR=$(SRCDIR)/$@ ARCH=$(ARCH)
 
 clean:
-	rm -f *~
-	@for d in $(SUBDIRS); do \
+	@rm -vrf *~
+	@set -e ; for d in $(SUBDIRS); do \
 		if [ -d $(OBJDIR)/$$d ]; then \
 			$(MAKE) -C $(OBJDIR)/$$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d clean; \
 		fi; \
 	done
 
 install:
-	@for d in $(SUBDIRS); do \
+	@set -e ; for d in $(SUBDIRS); do \
 		mkdir -p $(OBJDIR)/$$d; \
 		$(MAKE) -C $(OBJDIR)/$$d -f $(SRCDIR)/$$d/Makefile SRCDIR=$(SRCDIR)/$$d install; done

=== apps/Makefile ===
--- 
+++ 
@@ -37,45 +37,78 @@
 SRCDIR = .
 
 VPATH = $(SRCDIR)
+TOPDIR = $(SRCDIR)/..
 
 include $(SRCDIR)/../Make.defaults
 
-TOPDIR = $(SRCDIR)/..
+LINUX_HEADERS	= /usr/src/sys/build
+APPSDIR		= $(LIBDIR)/gnuefi/apps
+CPPFLAGS	+= -D__KERNEL__ -I$(LINUX_HEADERS)/include
 
-CDIR=$(TOPDIR)/..
-LINUX_HEADERS	= /usr/src/sys/build
-CPPFLAGS	+= -D__KERNEL__ -I$(LINUX_HEADERS)/include
-CRTOBJS		= ../gnuefi/crt0-efi-$(ARCH).o
+ifneq ($(HAVE_EFI_OBJCOPY),)
+ifeq ($(SYSTEM_HAS_EFI_OBJCOPY),0)
+CRT0_LOCAL = -local
+LDS_LOCAL = _local
+endif
+endif
 
-LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_efi.lds
-ifneq (,$(findstring FreeBSD,$(OS)))
+ifeq ($(IS_MINGW32),)
+# The CRT0 libs are only needed for non MinGW platforms
+CRT0_LIBS	= -lgnuefi
+endif
+
+ifneq ($(CRT0_LIBS),)
+CRTOBJS		= $(TOPDIR)/$(ARCH)/gnuefi/crt0-efi-$(ARCH)$(CRT0_LOCAL).o
+
+LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_efi$(LDS_LOCAL).lds
+ifeq ($(USING_FREEBSD),1)
 LDSCRIPT	= $(TOPDIR)/gnuefi/elf_$(ARCH)_fbsd_efi.lds
 endif
+LDFLAGS		+= -L$(TOPDIR)/$(ARCH)/lib -L$(TOPDIR)/$(ARCH)/gnuefi $(CRTOBJS)
+LOADLIBES	+= -T $(LDSCRIPT)
+endif
 
-LDFLAGS		+= -shared -Bsymbolic -L../lib -L../gnuefi $(CRTOBJS)
+LDFLAGS		+= -shared -Bsymbolic -L$(TOPDIR)/$(ARCH)/lib
 
-LOADLIBES	+= -lefi -lgnuefi
+LOADLIBES	+= -lefi $(CRT0_LIBS)
 LOADLIBES	+= $(LIBGCC)
-LOADLIBES	+= -T $(LDSCRIPT)
 
-TARGET_APPS = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi \
-	      printenv.efi t7.efi t8.efi tcc.efi modelist.efi \
-	      route80h.efi drv0_use.efi AllocPages.efi \
-	      FreePages.efi setjmp.efi debughook.efi debughook.efi.debug
+TARGET_APPS  = t.efi t2.efi t3.efi t4.efi t5.efi t6.efi t7.efi t8.efi \
+               tcc.efi printenv.efi modelist.efi route80h.efi drv0_use.efi \
+               AllocPages.efi exit.efi FreePages.efi bltgrid.efi \
+               lfbgrid.efi setdbg.efi unsetdbg.efi old_ABI.efi
+ifeq ($(IS_MINGW32),)
+TARGET_APPS += setjmp.efi debughook.efi debughook.efi.debug \
+               ctors_test.efi ctors_dtors_priority_test.efi
+endif
+
+ifeq ($(USING_FREEBSD),0)
 TARGET_BSDRIVERS = drv0.efi
+else
+TARGET_BSDRIVERS =
+endif
 TARGET_RTDRIVERS =
-
-ifneq ($(HAVE_EFI_OBJCOPY),)
-
-FORMAT		:= --target efi-app-$(ARCH)
-$(TARGET_BSDRIVERS): FORMAT=--target efi-bsdrv-$(ARCH)
-$(TARGET_RTDRIVERS): FORMAT=--target efi-rtdrv-$(ARCH)
-
-else
 
 SUBSYSTEM	:= 0xa
 $(TARGET_BSDRIVERS): SUBSYSTEM = 0xb
 $(TARGET_RTDRIVERS): SUBSYSTEM = 0xc
+
+ifeq ($(SYSTEM_HAS_EFI_OBJCOPY),1)
+
+FORMAT		:= -O efi-app-$(ARCH)
+$(TARGET_BSDRIVERS): FORMAT=-O efi-bsdrv-$(ARCH)
+$(TARGET_RTDRIVERS): FORMAT=-O efi-rtdrv-$(ARCH)
+
+ifneq ($(IS_MINGW32),)
+LDFLAGS     += -s -Wl,-dll -Wl,--subsystem,$(SUBSYSTEM) 
+ifeq ($(ARCH),ia32)
+LDFLAGS     += -e _efi_main
+else
+LDFLAGS     += -e efi_main
+endif
+endif
+
+else
 
 FORMAT		:= -O binary
 LDFLAGS		+= --defsym=EFI_SUBSYSTEM=$(SUBSYSTEM)
@@ -86,8 +119,14 @@
 
 all:	$(TARGETS)
 
+ctors_test.so : ctors_fns.o ctors_test.o
+
 clean:
-	rm -f $(TARGETS) *~ *.o *.so
+	@rm -vf $(TARGETS) *~ *.o *.so
+
+install:
+	mkdir -p $(INSTALLROOT)$(APPSDIR)
+	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)$(APPSDIR)
 
 .PHONY: install

=== gnuefi/Makefile ===
--- 
+++ 
@@ -37,39 +37,89 @@
 SRCDIR = .
 
 VPATH = $(SRCDIR)
+TOPDIR = $(SRCDIR)/..
 
 include $(SRCDIR)/../Make.defaults
 
-TOPDIR = $(SRCDIR)/..
-
-CDIR=$(TOPDIR)/..
+PKGCONFIGDIR ?= $(LIBDIR)/pkgconfig
 FILES	= reloc_$(ARCH)  
 
 OBJS	= $(FILES:%=%.o)
 
+ifneq ($(HAVE_EFI_OBJCOPY),)
+  gnu_efi_default_is_objcopy=true
+else
+  gnu_efi_default_is_objcopy=false
+endif
+# https://uefi.org/specs/UEFI/2.10/03_Boot_Manager.html#uefi-image-types
+ifeq ($(ARCH),x86_64)
+  efi_machine_type_name=x64
+endif
+ifeq ($(ARCH),ia32)
+  efi_machine_type_name=ia32
+endif
+ifeq ($(ARCH),arm)
+  efi_machine_type_name=arm
+endif
+ifeq ($(ARCH),aarch64)
+  efi_machine_type_name=aa64
+endif
+ifeq ($(ARCH),ia64)
+  efi_machine_type_name=ia64
+endif
+ifeq ($(ARCH),riscv64)
+  efi_machine_type_name=riscv64
+endif
+ifeq ($(ARCH),loongarch64)
+  efi_machine_type_name=loongarch64
+endif
+ifeq ($(ARCH),mips64el)
+  efi_machine_type_name=mips64
+endif
+
 # on aarch64, avoid jump tables before all relocations have been processed
 reloc_aarch64.o: CFLAGS += -fno-jump-tables
 
-TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a
+ifneq (,$(filter $(ARCH),aarch64 riscv64 ia32))
+CRT0_LOCAL_TARGET = crt0-efi-$(ARCH)-local.o
+endif
 
-all:	$(TARGETS)
+TARGETS	= crt0-efi-$(ARCH).o libgnuefi.a $(CRT0_LOCAL_TARGET)
 
-libgnuefi.a: $(patsubst %,libgnuefi.a(%),$(OBJS))
+all:	$(TARGETS) gnu-efi.pc
+
+libgnuefi.a: $(OBJS)
+	@$(ECHO) "  AR       $(notdir $@)"
+	$(HIDE)$(AR) $(ARFLAGS) $@ $^
+
+gnu-efi.pc:
+	@$(ECHO) "  GEN      $(notdir $@)"
+	$(HIDE)sed \
+		-e 's:@PREFIX@:$(PREFIX):g' \
+		-e 's:@EXEC_PREFIX@:$(EXEC_PREFIX):g' \
+		-e 's:@INCLUDEDIR@:$(INCLUDEDIR):g' \
+		-e 's:@LIBDIR@:$(LIBDIR):g' \
+		-e 's:@VERSION@:$(VERSION):g' \
+		-e 's:@efi_machine_type_name@:$(efi_machine_type_name):g' \
+		-e 's:@gnu_efi_arch@:$(ARCH):g' \
+		-e 's:@gnu_efi_default_is_objcopy@:$(gnu_efi_default_is_objcopy):g' \
+	$(SRCDIR)/gnu-efi.pc.in > gnu-efi.pc
+
 
 clean:
-	rm -f $(TARGETS) *~ *.o $(OBJS)
+	@rm -vf $(TARGETS) *~ *.o $(OBJS) gnu-efi.pc
 
 install:
 	mkdir -p $(INSTALLROOT)$(LIBDIR)
 	$(INSTALL) -m 644 $(TARGETS) $(INSTALLROOT)$(LIBDIR)
-ifneq (,$(findstring FreeBSD,$(OS)))
- ifeq ($(ARCH),x86_64)
+ifneq (,$(filter $(ARCH),x86_64 ia32))
 	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_fbsd_efi.lds $(INSTALLROOT)$(LIBDIR)
- else
+endif
+ifneq (,$(filter $(ARCH),aarch64 riscv64 ia32))
+	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi_local.lds $(INSTALLROOT)$(LIBDIR)
+endif
 	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi.lds $(INSTALLROOT)$(LIBDIR)
- endif
-else
-	$(INSTALL) -m 644 $(SRCDIR)/elf_$(ARCH)_efi.lds $(INSTALLROOT)$(LIBDIR)
-endif
+	$(INSTALL) -d $(INSTALLROOT)$(PKGCONFIGDIR)
+	$(INSTALL) -m 644 gnu-efi.pc $(INSTALLROOT)$(PKGCONFIGDIR)
 
 include $(SRCDIR)/../Make.rules

=== lib/Makefile ===
--- 
+++ 
@@ -43,9 +43,9 @@
 
 FILES = boxdraw smbios console crc data debug dpath \
         entry error event exit guid hand hw init lock \
-        misc pause print sread str cmdline\
-	runtime/rtlock runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata  \
-	$(ARCH)/initplat $(ARCH)/math $(ARCH)/setjmp
+        misc pause print sread str cmdline runtime/rtlock \
+        runtime/efirtlib runtime/rtstr runtime/vm runtime/rtdata \
+        $(ARCH)/initplat $(ARCH)/math $(ARCH)/setjmp
 
 ifeq ($(ARCH),ia64)
 FILES += $(ARCH)/salpal $(ARCH)/palproc
@@ -64,8 +64,6 @@
 
 SUBDIRS = ia32 x86_64 ia64 aarch64 arm mips64el riscv64 loongarch64 runtime
 
-LIBDIRINSTALL = $(INSTALLROOT)$(LIBDIR)
-
 all: libsubdirs libefi.a
 
 .PHONY: libsubdirs
@@ -75,17 +73,14 @@
 $(OBJS): libsubdirs
 
 libefi.a: $(OBJS)
-	$(AR) $(ARFLAGS) $@ $^
+	@$(ECHO) "  AR       $(notdir $@)"
+	$(HIDE)$(AR) $(ARFLAGS) $@ $^
 
 clean:
 	@rm -vf libefi.a *~ $(OBJS) */*.o
 
-$(LIBDIRINSTALL):
-	mkdir -p $@
-
-$(LIBDIRINSTALL)/libefi.a: libefi.a | $(LIBDIRINSTALL)
-	$(INSTALL) -m 644 $< $(dir $@)
-
-install: $(LIBDIRINSTALL)/libefi.a
+install:
+	mkdir -p $(INSTALLROOT)$(LIBDIR)
+	$(INSTALL) -m 644 libefi.a $(INSTALLROOT)$(LIBDIR)
 
 include $(SRCDIR)/../Make.rules

=== debian/changelog ===
gnu-efi (4.0.0-1) unstable; urgency=medium

  * Team upload
  * Change sf.net Homepage to Github

  [ Julian Andres Klode ]
  * debian/watch: Use new github.com repository (Closes: #1089642)
  * New upstream version 4.0.0
  * debian/copyright: Point to github repository as well

 -- Bastian Germann <bage@debian.org>  Wed, 07 Jan 2026 22:27:51 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Standards-Version: 4.1.1
 Vcs-Git: https://salsa.debian.org/efi-team/gnu-efi.git
 Vcs-Browser: https://salsa.debian.org/efi-team/gnu-efi
-Homepage: http://sourceforge.net/projects/gnu-efi/
+Homepage: https://github.com/ncroxon/gnu-efi
 
 Package: gnu-efi
 Architecture: any-amd64 any-i386 any-arm64 armhf any-riscv64 any-loong64 any-ia64

=== debian/watch ===
version=4
opts=\
filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
searchmode=plain \
  https://api.github.com/repos/ncroxon/gnu-efi/git/matching-refs/tags/ \
  https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
